#include <mutex>
#include <functional>
#include <map>

// ROS2
#include <rclcpp/rclcpp.hpp>
{% for d in data %}
#include <{{ pkgname }}/srv/get_{{ d.name }}_data.hpp>
{% endfor%}

// ROS1
#include <ros/ros.h>
{% for d in data %}
#include <{{ pkgname }}/Get{{ d.name|capitalize }}Data.h>
{% endfor%}

// Conversion functions
{% for d in data %}
#include "{{ d.name }}_convert.hpp"
{% endfor%}

class DataBridge : public rclcpp::Node
{
public:
   explicit DataBridge(const rclcpp::NodeOptions & options = rclcpp::NodeOptions())
  : Node("data_bridge", options)
  {
    RCLCPP_DEBUG(this->get_logger(), "initializing data bridge ROS2 server");
    {% for d in data %}
    this->{{ d.name }}_get_srv_ = this->create_service<{{ pkgname }}::srv::Get{{ d.name|capitalize }}Data>("data/get_{{ d.name }}",
      std::bind(&DataBridge::get_{{ d.name }}, this, std::placeholders::_1, std::placeholders::_2));
    {% endfor %}
    RCLCPP_INFO(this->get_logger(), "server ready"); 
    {% for d in data %}
    this->{{ d.name }}_get_client_ = n.serviceClient<{{ pkgname }}::Get{{ d.name|capitalize }}Data>("data/get_{{ d.name }}", true);
    {% endfor %}
  }

  void connect() {
    RCLCPP_INFO(this->get_logger(), "connecting to ROS1 client");
    {% for d in data %}
    this->{{ d.name }}_get_client_.waitForExistence();
    {% endfor %}
    this->connected = true;
    RCLCPP_INFO(this->get_logger(), "client ready");
  }

  bool connected = false;

private:
  ros::NodeHandle n; 
  // Resources servers (ROS2)
  {% for d in data %}
  rclcpp::Service<{{ pkgname }}::srv::Get{{ d.name|capitalize }}Data>::SharedPtr {{ d.name }}_get_srv_;
  {% endfor %}
  // Resources clients (ROS1)
  {% for d in data %}
  ros::ServiceClient {{ d.name }}_get_client_;
  {% endfor %}
  // Callbacks
  {% for d in data %}
  void get_{{ d.name }}(const std::shared_ptr<{{ pkgname }}::srv::Get{{ d.name|capitalize }}Data::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::Get{{ d.name|capitalize }}Data::Response> response) 
  {
    (void)request;
    {{ pkgname }}::Get{{ d.name|capitalize }}Data srv;
    RCLCPP_INFO(this->get_logger(), "get data {{ d.name }}");
    auto result = this->{{ d.name }}_get_client_.call(srv);
    if (result) {
      RCLCPP_DEBUG_STREAM(this->get_logger(), "data: " << srv.response.data);
      {{ d.name }}_convert(*response, srv.response);
    } else
      RCLCPP_WARN(this->get_logger(), "error getting data {{ d.name }}");
      this->connected = false;
  }
  {% endfor %}
};

void spinThread()
{
  ros::spin();
}

int main(int argc, char ** argv)
{
  // ROS 2
  printf("Initializing ROS2\n");
  rclcpp::init(argc, argv);

  // ROS 1 node
  printf("Initializing ROS1 Node\n");
  ros::init(argc, argv, "data_bridge");
  ros::NodeHandle ros1_node;

  // Bridge
  auto node = std::make_shared<DataBridge>();

  // ROS 1 asynchronous spinner
  ros::AsyncSpinner async_spinner(1);
  async_spinner.start();

  // ROS 2 spinning loop
  rclcpp::executors::SingleThreadedExecutor executor;
  while (ros1_node.ok() && rclcpp::ok()) {
    if (node->connected)
      executor.spin_node_once(node, std::chrono::milliseconds(100));
    else
      node->connect();    
  }

  return 0;
}
